<template>
  <div class="map loading" v-if="loading">
    <div class="realmap-lp lp"></div>
  </div>
  <div v-else>
    <div
      :class="['map', expand && !isMobile && 'expand', scroll && 'scroll']"
      ref="wrapper"
      @dragstart.stop.prevent=""
      @dragscrollstart="move"
      v-dragscroll="scroll"
    >
      <div ref="map" class="image">
        <img :src="image" :style="imageStyle" @load="loaded" ref="image" />
        <router-link
          class="pin"
          v-for="restaurant in restaurants"
          :key="restaurant.id"
          :style="{
            left: pinPos(restaurant.realMapPosition).x + 'px',
            top: pinPos(restaurant.realMapPosition).y + 'px'
          }"
          :to="{
            name: 'RestaurantBooking',
            params: {
              groupId: restaurant.groupId,
              companyId: restaurant.company.id,
              id: restaurant.id
            }
          }"
        >
          <div class="pin__logo">
            <div
              class="pin__logo-img overflow-hidden abs-full bg-center-contain-nr"
              :style="{ 'background-image': `url('${restaurant.logo}')` }"
            ></div>
          </div>
          <div class="pin__location">{{ restaurant.name }}</div>
        </router-link>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters } from "vuex";

export default {
  props: {
    scroll: {
      type: Boolean
    },
    image: {
      type: String
    },
    restaurants: {
      type: Array
    },
    center: {
      type: Object
    },
    expand: {
      type: Boolean
    }
  },

  data() {
    return {
      sizeRato: 1,
      width: 0,
      height: 0,
      originalWidth: 0,
      originalHeight: 0,
      scrolled: false,
      imageLoaded: false
    };
  },

  computed: {
    ...mapState(["windowSize"]),
    ...mapState("group", ["loading"]),
    ...mapState(["isMobile"]),

    imageStyle() {
      const style = { opacity: "0" };
      if (!this.imageLoaded) {
        return style;
      }
      if (this.width) {
        style.width = this.width + "px";
      }
      if (this.height) {
        style.height = this.height + "px";
      }
      style.opacity = "1";
      return style;
    }
  },

  watch: {
    windowSize() {
      this.updateImageStyle();
    },
    center(val) {
      if (val) {
        this.moveToCenter();
      }
    }
  },

  methods: {
    loaded(e) {
      if (this.imageLoaded) {
        return;
      }
      const image = e.target;
      this.sizeRato = image.width / image.height;
      this.originalWidth = image.width;
      this.originalHeight = image.height;
      this.imageLoaded = true;
      this.$emit("mapLoaded");
      this.$forceUpdate();
    },

    pinPos(pos) {
      return {
        x: (this.width / this.originalWidth) * pos.x,
        y: (this.height / this.originalHeight) * pos.y + 52
      };
    },

    moveToCenter() {
      if (!this.$refs.wrapper) {
        return;
      }
      const wrapper = this.$refs.wrapper;
      const wrapperRect = wrapper.getBoundingClientRect();
      const realCenter = {
        x: this.width / 2,
        y: this.height / 2
      };
      const newCenter = this.center ? this.pinPos(this.center) : realCenter;
      wrapper.scrollTop =
        (this.height - wrapperRect.height) / 2 + (newCenter.y - realCenter.y);
      wrapper.scrollLeft =
        (this.width - wrapperRect.width) / 2 + (newCenter.x - realCenter.x);
      this.$emit("center");
    },

    updateImageStyle() {
      if (!this.$refs.image) {
        return;
      }
      const image = this.$refs.image;
      const wrapper = this.$refs.wrapper;
      const wrapperRect = wrapper.getBoundingClientRect();
      const wrapperSizeRatio = wrapperRect.width / wrapperRect.height;
      let width;
      let height;

      if (wrapperSizeRatio > this.sizeRato) {
        width = this.isMobile ? wrapperRect.width * 2 : wrapperRect.width;
        height = width / this.sizeRato;
      } else {
        height = this.isMobile ? wrapperRect.height * 2 : wrapperRect.height;
        width = height * this.sizeRato;
      }

      if (this.width !== width || this.height !== height) {
        this.width = width;
        this.height = height;
      }

      if (!this.scrolled) {
        this.moveToCenter();
      }
      this.$emit("handleScroll");
    },

    move() {
      this.scrolled = true;
      this.$emit("move");
    }
  },

  updated() {
    this.$nextTick(() => {
      this.updateImageStyle();
    });
  },

  mounted() {
    this.$nextTick(() => {
      this.updateImageStyle();
    });
  }
};
</script>

<style lang="scss" scoped>
.map {
  overflow: hidden;
  position: absolute;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;

  &.expand {
    overflow: visible;
    position: relative;
  }

  &.scroll {
    overflow: scroll;
  }
}

.realmap-lp {
  position: absolute;
  top: 0;
  left: 0;
  width: 0;
  height: 100%;
}

.pin {
  position: absolute;
  z-index: 1;
  transition: all 0.3s;
  transform: translateY(-50px);
  width: 1px;
  height: 1px;
  color: inherit;

  &:hover {
    z-index: 2;
  }

  &.show {
    transform: none;
    opacity: 1;
    transition: all 0.3s 0.3s;
  }
}

.pin__logo {
  position: absolute;
  bottom: 0;
  transform: translateX(-50%) translateY(-8px);
  z-index: 1;
  background-color: $color-white;
  width: 60px;
  height: 60px;
  padding: 3px;
  border: 2px solid $color-white;
  border-radius: 50%;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);

  &:after {
    content: "";
    position: absolute;
    bottom: -8px;
    left: 50%;
    transform: translateX(-50%);
    border-width: 8px 5px 0 5px;
    border-color: $color-white transparent transparent transparent;
    border-style: solid;
  }

  &:before {
    content: "";
    position: absolute;
    right: -7px;
    top: 12px;
    height: 32px;
    width: 10px;
    background: $color-white;
    padding: 0;
    margin: 0;

    @include media-breakpoint-down(sm) {
      display: none;
    }
  }
}

.pin__logo-img {
  border-radius: 50%;
}

.pin__location {
  position: absolute;
  left: 4px;
  top: -54px;
  background-color: $color-white;
  line-height: 34px;
  height: 34px;
  border-radius: 0 17px 17px 0;
  bottom: 0;
  padding: 0 13px 0 32px;
  white-space: nowrap;
  font-size: 14px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.2);

  @include media-breakpoint-down(sm) {
    display: none;
  }
}
</style>
